/* binA2P.c

   Martin Woelz 26 July 2002
   woelz@math.uni-goetingen.de

   Convert binary to ASCII-printable

   Intended for simple binary reconstruction
   by short EPSON HX-20 BASIC program UPLOAD.BAS


   DESCRIPTION
   -----------
   Each byte is split into upper and lower 4 bits. They are mapped
   to 65..80, ASCII "A".."P" respectively. Lower 4 bits are put out first.


   COMPILE
   -------
   gcc -o binA2P binA2P.c ; strip binA2P

*/

#include<stdio.h>

int main(int no_arg, char *argv[])
{
  FILE* sourcefile;
  int c;

  if (no_arg != 2)
    {
      fprintf(stderr, "Usage: %s 'binary_filename'\n", argv[0]);
      return 1;
    }

  sourcefile = fopen(argv[1], "r");

  while((c = fgetc(sourcefile)) != EOF)
    {
      putchar((c & 0x0f) + 65);
      putchar(((c & 0xf0) >> 4) + 65);
      putchar('\n');
    }

  return 0;
}
